import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Observable;

/**
 * @version 6, Oct 10
 * In this version, the Counter has become an Observable, so that it can maintain its own
 * state and inform all its Observers (typically "view" components) of the change without
 * having to worry about exactly what those Observers are.
 */
public class Counter extends Observable
{
    private int current = 0;
    private ActionListener incr;
    
    public Counter ()
    {
        this.incr = new ActionListener()
        {
 
            public void actionPerformed (ActionEvent e)
            {
                Counter.this.current++;
                Counter.this.setChanged();
                notifyObservers(new Integer(current));
//              or, to be pedantic,
//              Counter.this.notifyObservers(new Integer(Counter.this.current));
            }
        };
    }

    public ActionListener getIncrementer ()
    {
        return this.incr;
    }


}
